/******************* (C) COPYRIGHT 2009~2024 holychip **************************
* File Name          : HC89F34x1C_GeneralKey_Touch_Lib_CFG_H.h
* Author             : HA TeamZ
* Version            : V3.0.4.0    
* Date               : 2024/12/02
********************************************************************************

עHCTouchLibͷĺ궨壬ûԸʵʵҪ޸ĺ

*******************************************************************************/
#ifndef __HC89F34x1C_GeneralKey_Touch_Lib_CFG_H__
#define __HC89F34x1C_GeneralKey_Touch_Lib_CFG_H__


/*******************************************ôؼĴ*********************************************************************************/
	
//      ݲʱӸ(0~255) ͨɨʱ  ((HCTouchLib_DSCR+1)*256 - 1)/(Fosc/2)
#define HCTouchLib_DSCR                                 80

//      ôԴѹ(0~3)   0->2v 1->2.5v 2->3v 3->4vѹԽ󣬴ֵԽ
//      ʹע⣺뱣֤оƬVDDѹ > ûôԴѹ+0.5V
#define HCTouchLib_VD                                   2

//      ôŵ(3~6)       3->ŵС, 6->ŵ,3(С)-->6(), ŵԽС,RawDataֵԽС
#define HCTouchLib_RBS                                  3
	

/*******************************************ôز*******************************************************************************/

//      Ҫͨ ע⣺˴ȷͨ־Ӧͨ־һ6˴6г
#define HCTouchLib_OPENED_TK_AMOUNT                     6

//      Ҫͨ־ ------>[0: ⣻1: ]													
//      HC89F303C-SOP28        		TK0 TK1 TK2 TK3 TK4 TK5 TK6 TK7 TK8 TK9 TK10TK11TK12TK13TK14TK15TK16TK17TK18TK19TK20
#define HCTouchLib_TK_CH_MASK  		{ 0  , 0  , 0  , 0  , 0  , 0  , 0  , 0  , 0  , 0  , 1  , 1  , 1  , 1  , 1  , 1  , 0  , 0  , 0  , 0  ,  0 }													
                                                                                                                                  
//      ö̰ ------>[0: ̰  1: ]
//		ʹע⣺ñϳ/̰Чʱʹ
#define HCTouchLib_TK_LONGKEY  		{ 0  , 0  , 0  , 0  , 0  , 0  , 0  , 0  , 0  , 0  , 0  , 0  , 0  , 0  , 0  , 0  , 0  , 0  , 0  , 0  ,  0 }	

//      ֵָ(25~65535)          
#define HCTouchLib_FINGER_THRESHOLD	{ 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200}	
	
//      ȷϰЧֵ(40~1000)	Differ>ֵָ*ȷϰЧֵ/100󰴼Ч
#define HCTouchLib_CONFIRM_TOUCH_RATIO					70
	
//      ȷϰЧֵ(20~1000)	Differ<ֵָ*ȷϰЧֵ/100󰴼ʧЧ
#define HCTouchLib_CONFIRM_NOTOUCH_RATIO				60		
	
//      Чֵ(0~255)       ֵ = HCTouchLib_LIMIT_FACTOR  ӦͨĴֵ0ʾ
#define HCTouchLib_LIMIT_FACTOR                         0	

//      ȷ(1~255)		ʱ = ɨʱ  ļͨ  ȷ
#define HCTouchLib_CONFIRM_TOUCH_TIME                   2

//      뿪(1~255)		ɿʱ = ɨʱ  ļͨ  뿪
#define HCTouchLib_CONFIRM_NOTOUCH_TIME                 2
	
	

/*******************************************û߸ز*******************************************************************************/
//                                                                   Differ																	 																	 														 
//      һɨʱ = ͨɨʱ  ļͨ            					
//      IIIIV ĸʱ  ֵ  һɨʱ            
//      III΢ԭ Differۼֵ > ֵ ʱ ΢             
//------------------------------------------------------------------------------------------------------------------Чֵ
//      ö̰Чʱ(0~2000)                                      Differ>ֵ+ʱڲۼֵ
#define HCTouchLib_CONFIRM_SHORTTOUCH_TIME              500     //          Iֵ󣬰Ч»																			 
//                                                                     I          
//      óЧʱ(SHORTTOUCH_TIME~65535)                       																	 
#define HCTouchLib_CONFIRM_LONGTOUCH_TIME               3000    //          																			 
//                                                                          																		 
//------------------------------------------------------------------------------------------------------------------ֵ
//      ׼߸ʱ(0~65535)                                       Differ0봥ֵ֮ʱڲۼ	
#define HCTouchLib_OVERZERO_TIME                        100     //    II    ֵIIֵ󣬰Ч»	         															 
//                                                                          																			 
//------------------------------------------------------------------------------------------------------------------
//      õͻ׼߸λʱ(0~255)                                         Differ<0ʱڲۼֵIV
#define HCTouchLib_OVERLOW_TIME                         50      //    IV    ֵ󣬰Ч»	   																				
//------------------------------------------------------------------------------------------------------------------
//      CTKϵ紥ȶʱ(0~65535)
//		0ϵȶʱ
//		1~65535ʼɨHCTouchLib_STABLE_TIMEڣһֱ»߲TouchKeyFlag
#define HCTouchLib_STABLE_TIME                 			20		


/****************************************************************************************************/

#endif /*__HC89F34x1C_GeneralKey_Touch_Lib_CFG_H__*/

/******************************************************************************************************
 * Revision history:
 *
 * Revision 1.01	2017/12/18 14:10 Taboo.ZZ
 * Revision 1.0.2.0	2018/07/20 16:26 Jing.LZ
 * Revision 1.0.3.0	2018/09/10 14:26 Jing.LZ
 * Add: 1˳Ͳ
 *		2ɾ˲ּĴԲ
 *		3Ű
 * Revision 1.0.4.0	2019/03/06 10:44 Touch Team
 * Add: 1ɾ˲ּĴԲ
 *		2HCTouchLib_CONFIRM_LONGTOUCH_TIMEпɶ̬޸
 * Revision 1.0.5.0	2019/09/17 19:24 Touch Team
 * Add: 1HCTouchLib_TK_CH_MASK16ƸΪ2
 *		2ֲ޸
 * Revision 2.0.0.0	2020/05/29 15:29 HA Team
 * Add: 1HC89F34x1CоƬӲʹ
 *		2ֵֵʽ޸
 *      3ë޸ģ޸ΪЧֵ
 *      4ӳ̰̰İЧʱԷֱ
 *      5ͻ׼߸λЧʱ
 * Revision 3.0.0.0	2021/04/08 10:41 HA Team
 * Add: 1ɾӲʹ
 *		2ȷϰЧ/Чֵ
 *      3ɾز
 *      4ɾŵƵ
 * Revision 3.0.2.0	2023/11/28 14:47 HA Team
 * Add: 1CTKϵȶʱ
 * Revision 3.0.3.0	2023/12/05 15:59 HA Team
 * Add: 1ļ޸
 * Revision 3.0.4.0	2024/03/21 15:59 HA Team
 * Add: 1ļ޸ 
 *
 ******************************************************************************************************/
